
public class ClassCastTester1 {
	public static void main(String[] args) {
		B b = new B();
		/* Static type of b is B ; Dynamic type of b is B */
		
		/* Upward casting compiles ok
		 * because the cast type A is ancestor of b's static type B.
		 * This cast is also exectued ok at runtime,
		 * because the cast type A is an acestor of b's dynamic type B. 
		 */
		A a = (A) b; 
		
		/* This method call compiles ok 
		 * because 'am' is defined in a's static type A.
		 * Due to dynamic binding, it will call the version of
		 * 'am' overridden in a's dynamic type B. */
		a.am(); /* print: B.am */
		
		/* These two method calls do not compile (uncomment these two lines to see it)
		 * because 'bm' and 'cm' are  not defined in a's static type A. */
//		a.bm();  
//		a.cm();
		
		/* Upward casting compiles ok
		 * because the cast type C is descendant of b's static type B.
		 * But this cast is exectued at runtime with ClassCastException,
		 * because the cast type C is not an acestor of b's dynamic type B. 
		 */
		C c = (C) b;
		/* These three method calls are not reachable 
		 * because the above cast throw a ClassCastException. */
		c.am();
		c.bm();
		c.cm();
	}
}
