
public class ClassCastTester2 {
	public static void main(String[] args) {
		B b = new C();
		/* static type of b is B; dynamic type of b is C */
		
		/* This cast does not compile (uncomment the line to see this)
		 * because the cast type D is neither
		 * an ancestor nor a descendant of b's static type B */
//		D d1 = (D) b;
		
		/* Here is an example to trick the compiler:
		 * first up-cast 'b' to an ancestor class of D (i.e., A),
		 * then down-cast it to a descendant class of A (i.e., D).
		 */
		A a = (A) b;
		/* will still run into ClassCastException because
		 * the cast type D is not an ancestor of a's dynamic type C. */
		D d2 = (D) a; 
		
		/* This line is just a shorthand to the above two casts
		 * without the intermediate variable.
		 * Still, it will run into ClassCastException for 
		 * the same reason. */
		D d3 = (D) ((A) b);
	}
}
